# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python or TypeScript SDK.  To install the official [Python SDK](https://pypi.org/project/humanloop/), run the following command:  ```bash pip install humanloop ```  To install the official [TypeScript SDK](https://www.npmjs.com/package/humanloop), run the following command:  ```bash npm i humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://docs.humanloop.com/).

    The version of the OpenAPI document: 4.0.1
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal, TYPE_CHECKING
from pydantic import BaseModel, Field, RootModel

from humanloop.pydantic.chat_message_with_tool_call import ChatMessageWithToolCall
from humanloop.pydantic.create_datapoint_request_inputs import CreateDatapointRequestInputs
from humanloop.pydantic.create_datapoint_request_target import CreateDatapointRequestTarget

class CreateDatapointRequest(BaseModel):
    inputs: typing.Optional[CreateDatapointRequestInputs] = Field(None, alias='inputs')

    # The chat messages for this datapoint.
    messages: typing.Optional[typing.List[ChatMessageWithToolCall]] = Field(None, alias='messages')

    target: typing.Optional[CreateDatapointRequestTarget] = Field(None, alias='target')
    class Config:
        arbitrary_types_allowed = True
